import unittest

# from unittest.mock import patch

# from common.backend.utils.context_utils import (
#     add_llm_step_trace,
#     get_llm_trace_dicts,
#     get_total_time_taken,
#     init_user_data,
#     llm_step_traces,
#     log_llm_step_trace,
#     reset_llm_step_trace,
# )

# trace_example = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:17.739Z",
#             "end": "2025-01-27T08:22:19.960Z",
#             "duration": 123,
#             "name": "TEST_NAME",
#             "children": [],
#             "attributes": {"key": "value"},
#             "inputs": {"messages": [{"role": "system","text": "example text"}]},
#             "outputs": {"text": "string"},
# }


class TestLLMStepTraceFunctions(unittest.TestCase):
    pass
#     def setUp(self):
#         llm_step_traces.set([])

#     def test_init_user_data(self):
#         init_user_data()
#         self.assertEqual(llm_step_traces.get(), [])

#     def test_add_llm_step_trace_valid(self):
#         add_llm_step_trace(trace_example)
#         self.assertEqual(llm_step_traces.get(), [trace_example])

#     def test_reset_llm_step_trace(self):
#         add_llm_step_trace(trace_example)
#         self.assertEqual(llm_step_traces.get(), [trace_example])

#         reset_llm_step_trace()
#         self.assertEqual(llm_step_traces.get(), [])

#     @patch("common.llm_assist.logging.logger.debug")
#     def test_log_llm_step_trace(self, mock_logger):
#         add_llm_step_trace(trace_example)
#         log_llm_step_trace()
#         mock_logger.assert_called_with(f"LLM steps: {[trace_example]}")

#     def test_get_llm_trace_dicts(self):
#         add_llm_step_trace(trace_example)
#         result = get_llm_trace_dicts()
#         self.assertEqual(result, [trace_example])

#     def test_get_total_time_taken(self):
#         trace1 = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:17.739Z",
#             "end": "2025-01-27T08:22:18.739Z",
#             "duration": 1000,
#             "name": "Step1",
#             "children": [],
#             "attributes": {},
#             "inputs": {},
#             "outputs": {},
#         }
#         trace2 = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:18.739Z",
#             "end": "2025-01-27T08:22:20.739Z",
#             "duration": 2000,
#             "name": "Step2",
#             "children": [],
#             "attributes": {},
#             "inputs": {},
#             "outputs": {},
#         }

#         add_llm_step_trace({"trace1": trace1})
#         add_llm_step_trace({"trace2": trace2})

#         total_time = get_total_time_taken()
#         self.assertEqual(total_time, 3.0)

#     def test_get_total_time_taken_missing_duration(self):
#         trace1 = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:17.739Z",
#             "end": "2025-01-27T08:22:18.739Z",
#             "duration": 1000,
#             "name": "Step1",
#             "children": [],
#             "attributes": {},
#             "inputs": {},
#             "outputs": {},
#         }
#         trace2 = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:18.739Z",
#             "end": "2025-01-27T08:22:20.739Z",
#             "name": "Step2",
#             "children": [],
#             "attributes": {},
#             "inputs": {},
#             "outputs": {},
#         }

#         add_llm_step_trace({"trace1": trace1})
#         add_llm_step_trace({"trace2": trace2})

#         total_time = get_total_time_taken()
#         self.assertEqual(total_time, 1.0)

#     @patch("common.llm_assist.logging.logger.error")
#     def test_get_total_time_taken_invalid_data(self, mock_logger):
#         trace = {
#             "type": "span",
#             "begin": "2025-01-27T08:22:17.739Z",
#             "end": "2025-01-27T08:22:18.739Z",
#             "duration": "somethings missing!",
#             "name": "Step1",
#             "children": [],
#             "attributes": {},
#             "inputs": {},
#             "outputs": {},
#         }
#         add_llm_step_trace({"trace": trace})

#         total_time = get_total_time_taken()
#         self.assertEqual(total_time, 0.0)
#         mock_logger.assert_called_once()

#     def test_get_total_time_taken_no_traces(self):
#         total_time = get_total_time_taken()
#         self.assertEqual(total_time, 0.0)

# if __name__ == "__main__":
#     unittest.main()